var VideoWidth = 0;
var VideoHeight = 0;
var VideoDuration = 0;
var modeName="";

var Player = {
	plugin : null,
	state : -1,
	stopCallback : null, /* Callback function to be set by client */

	STOPPED : 0,
	PLAYING : 1,
	PAUSED : 2,
	FORWARD : 3,
	REWIND : 4,
	duration : 0,
	current_time : 0
};

Player.init = function() {
	var success = true;
	this.state = this.STOPPED;
	this.plugin = document.getElementById("pluginPlayer");
	if (!this.plugin ) {
		Player.setWindow();
		success = false;
	}

	this.plugin.OnCurrentPlayTime = 'Player.setCurTime';
	this.plugin.OnStreamInfoReady = 'Player.OnStreamInfoReady';
	this.plugin.OnBufferingStart = 'Player.onBufferingStart';
	this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
	this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';

	return success;
};

Player.deinit = function() {
	alert("Player deinit !!!");
	if (this.plugin) {
		this.plugin.Stop();
	}
};


// переключение типа полноэкранного режима, значения от 1 до 3
Player.setScreenMode = function(modesize) {
	if (VideoWidth <= 0 || VideoHeight <= 0) {return -1;}

	var wCorr = VideoWidth < (VideoHeight * 4 / 3) ? VideoHeight * 4 / 3 : VideoWidth ;

	var crop = {
		x : 0,
		y : 0,
		w : VideoWidth ,
		h : VideoHeight
	};
	var disp = {
		x : 0,
		y : 0,
		w : ScreenWidth,
		h : ScreenHeight
	};

	switch (modesize) {
		case 1:
			if ( VideoWidth/VideoHeight < 16/9 ) {
				modeName="FullScreen 4x3.";
				var h1 = wCorr * 9 / 16;
				crop = {
					x : 0,
					y : parseInt( (VideoHeight - h1) / 2),
					w : VideoWidth ,
					h : parseInt(h1)
				};
			} else {
				modeName="FullScreen 16x9.";
				var w1 = VideoHeight * 16 / 9;
				crop = {
					x : parseInt( (VideoWidth - w1) / 2),
					y : 0,
					w : parseInt(w1),
					h : VideoHeight
				};
			}
			break;
		case 2:
			if (VideoWidth/VideoHeight < 16/9 ) {
				modeName="Original 4x3.";
				var h1 = ScreenHeight;
				var w1 = h1 * wCorr / VideoHeight;
				var x = (ScreenWidth - w1) / 2;
				if (x < 0)
					x = 0;
				disp = {
					x : parseInt(x),
					y : 0,
					w : parseInt(w1),
					h : parseInt(h1)
				};
			} else {
				modeName="Original 16x9.";
				var w1 = ScreenWidth;
				var h1 = w1 * VideoHeight / VideoWidth;
				var y = (ScreenHeight - h1) / 2;
				if (y < 0)
					y = 0;
				disp = {
					x : 0,
					y : parseInt(y),
					w : parseInt(w1),
					h : parseInt(h1)
				};
			}
			break;
		case 3:
			modeName="FullScreen 14x9.";
			crop = {
				x : 0,
				y : parseInt(0.0625 * VideoHeight),
				w : VideoWidth ,
				h : parseInt(0.875 * VideoHeight)
			};
			break;

		default:
			break;
	}
	this.plugin.SetCropArea(crop.x, crop.y, crop.w, crop.h);
	this.plugin.SetDisplayArea(disp.x, disp.y, disp.w, disp.h);

	Display.status(modeName);

	if (this.state == this.PAUSED) {
		this.plugin.Pause();
	}
};

Player.playVideo = function() {
	pluginAPI.unregistKey(tvKey.KEY_TOOLS);

	if (url == null || url == '') {
		alert("No videos to play");
	} else {
		this.state = this.PLAYING;
		if(!this.duration){
			Display.player_bars_hide = false;
		}
		pluginAPI.setOffScreenSaver();
		Display.showplayer();
		Display.status("Play");
		this.setFullscreen();
		this.plugin.Play(url);
		Audio.plugin.SetSystemMute(false);
	}

//	Display.statusLine ( "VideoWidth: "+VideoWidth+" VideoHeight:"+VideoHeight);
};

Player.setWindow = function() // видео скрыто
{this.plugin.SetDisplayArea(0, 0, 0, 0); };

Player.setFullscreen = function() // полноэкранный режим
{
	Main.setFullScreenMode();
	this.plugin.SetDisplayArea(0, 0, ScreenWidth, ScreenHeight);
};

Player.pauseVideo = function() // пауза
{
	this.state = this.PAUSED;
	Display.showplayer();
	Display.status("Pause");
	this.plugin.Pause();
	pluginAPI.setOnScreenSaver(300);
};

Player.stopVideo = function() // стоп
{
	if (this.state != this.STOPPED) {
		pluginAPI.registKey(tvKey.KEY_TOOLS);

		this.state = this.STOPPED;
		this.duration = 0;
		Display.player_bars_hide = false;
		Display.showplayer();
		Display.status("Stop");
		this.plugin.Stop();
		Display.setTime(0);
		if (this.stopCallback) {
			this.stopCallback();
		}
		Display.hideplayer();
		pluginAPI.setOnScreenSaver(300);
	} else {
		//alert("Ignoring stop request, not in correct state");
	}
};
Player.stopCallback = function () {
	// Return to windowed mode when video is stopped
	// (by choice or when it reaches the end)
	Main.setWindowMode();
};

Player.resumeVideo = function() // стоп кадр
{
	this.state = this.PLAYING;
	Display.player_bars_hide = true;
	Display.showplayer();
	Display.status("Play");
	this.plugin.Resume();
	pluginAPI.setOffScreenSaver();
};

Player.getState = function() // текущее состояние
{ return this.state; };

Player.skipForwardVideo = function() {
	this.skipState = this.FORWARD;
	Display.showplayer();
	this.plugin.JumpForward(30);
};

Player.skipForwardVideoFast = function() {
	this.skipState = this.FORWARD;
	Display.showplayer();
	this.plugin.JumpForward(120);
};

Player.skipBackwardVideo = function() {
	this.skipState = this.REWIND;
	Display.showplayer();
	this.plugin.JumpBackward(30);
};

Player.skipBackwardVideoFast = function() {
	this.skipState = this.REWIND;
	Display.showplayer();
	this.plugin.JumpBackward(120);
};

Player.PercentJump = function(percent) {
	this.statusmessage = percent*10 + "%";
	var jump_to_minutes = Math.round((VideoDuration*percent/10)/1000);
	if (jump_to_minutes > this.current_time/1000)
		this.plugin.JumpForward(jump_to_minutes - this.current_time/1000);
	else
		this.plugin.JumpBackward(this.current_time/1000 - jump_to_minutes);
	Display.showplayer();
	Display.status(this.statusmessage);
};

Player.onBufferingStart =function() {
	$('#player').addClass('loading');
	Display.status("Buffering...");
	//pluginAPI.setOnScreenSaver(300);
	switch (this.skipState) {
		case this.FORWARD:
			document.getElementById("forward").style.opacity = '0.5';
			break;

		case this.REWIND:
			document.getElementById("rewind").style.opacity = '0.5';
			break;
	}
};
Player.onBufferingProgress = function(percent) {
	$('#player').addClass('loading');
	Display.status("Buffering:" + percent + "%");
};
Player.onBufferingComplete = function() {
	$('#player').removeClass('loading');
	Display.status("Play");

	switch (this.skipState) {
		case this.FORWARD:
			document.getElementById("forward").style.opacity = '1.0';
			break;

		case this.REWIND:
			document.getElementById("rewind").style.opacity = '1.0';
			break;
	}
};

// функция таймера проигрывания трека, вызывается плагином:
Player.setCurTime = function(time) {
	this.current_time = time;
	Display.setTime(time);
};

// функция размера трека, вызывается плагином: plugin.OnStreamInfoReady
Player.OnStreamInfoReady = function() {
	//alert("OnStreamInfoReady");
	VideoDuration = Player.plugin.GetDuration();
	this.duration = VideoDuration;
	if(content_type == 'video'){
		VideoWidth = Player.plugin.GetVideoWidth();
		VideoHeight = Player.plugin.GetVideoHeight();
		Player.setScreenMode (currentFSMode);
	}
	Display.setTotalTime(VideoDuration);
	Display.player_bars_hide = true;
	Display.showplayer();
};

onServerError = function() {
	Display.status("Server Error!");
};
popupNetworkErr = function() {
	Display.status("Network Error!");
};
onNetworkDisconnected = function () {
	Display.status("Network Error!");
};
getBandwidth = function (bandwidth) {
	//alert("getBandwidth " + bandwidth);
};
onDecoderReady = function () {
	//alert("onDecoderReady");
};
onRenderError = function () {
	//alert("onRenderError");
};
stopPlayer = function () {
	Player.stopVideo();
};
setTottalBuffer = function (buffer) {
	//alert("setTottalBuffer " + buffer);
};